//ajaxApi地址设置
var ajaxUrlInit = {
	isJavaApi:false,//是否通过java转发
	basePath: "",
	addPath:"/h5"
};
var LoginState = false;
//获取链接参数
function getParam(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.search.substr(1).match(reg);
    if (r != null) return decodeURIComponent(r[2]); return null;
}

function getClientSize() {
	if (window.innerHeight) {
		return {
			width: window.innerWidth,
			height: window.innerHeight
		}
	} else {
		if (document.documentElement && document.documentElement.clientHeight) {
			return {
				width: document.documentElement.clientWidth,
				height: document.documentElement.clientHeight
			}
		} else {
			return {
				width: document.body.clientWidth,
				height: document.body.clientHeight
			}
		}
	}
}
function delHtmlTag(str) {
	return str.replace(/<[^>]+>/g, "")
}
function toCutStr(str, len) {
	if (str && str.length > len) {
		str = str.substr(0, len)
	}
	return str
}

function formatDate(date) {
	var newDate = eval("new " + (date.replace(/\//g, "")));
	return lastDateFormat(newDate.getTime());
}

function formatDateStr(date) {
	var newDate = eval("new " + (date.replace(/\//g, "")));
	return newDate.format("yyyy-MM-dd hh:mm");
}

function formatDateStr2(date) {
	var newDate = eval("new " + (date.replace(/\//g, "")));
	return newDate.format("yyyy-MM-dd hh:mm:ss");
}
Array.prototype.remove = function(dx) {
	if (isNaN(dx) || dx > this.length) {
		return false
	}
	for (var i = 0, n = 0; i < this.length; i++) {
		if (this[i] != this[dx]) {
			this[n++] = this[i]
		}
	}
	this.length -= 1
}
Date.prototype.format = function(format) {
	var o = {
		"M+": this.getMonth() + 1,
		"d+": this.getDate(),
		"h+": this.getHours(),
		"m+": this.getMinutes(),
		"s+": this.getSeconds(),
		"q+": Math.floor((this.getMonth() + 3) / 3),
		"S": this.getMilliseconds()
	};
	if (/(y+)/.test(format)) {
		format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length))
	}
	for (var k in o) {
		if (new RegExp("(" + k + ")").test(format)) {
			format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length))
		}
	}
	return format
}

function lastDateFormat(time) {
	var d1, d2, day, h, m, s, ms, d1ms, d2ms, dms, hms, mms;
	var dms = 1000 * 60 * 60 * 24;
	var hms = 1000 * 60 * 60;
	var mms = 1000 * 60;
	var ms = time - new Date().getTime();
	if (ms <= 0) {
		day = 0;
		h = 0;
		m = 0;
		s = 0;
		ss = 0 % 1000
	} else {
		day = Math.floor(ms / dms);
		h = Math.floor(ms % dms / hms);
		m = Math.floor(ms % hms / mms);
		s = Math.floor(ms % mms / 1000);
		var ss = Math.floor(ms % 1000)
	} if (day <= 9) {
		day = "0" + day
	}
	if (h <= 9) {
		h = "0" + h
	}
	if (m <= 9) {
		m = "0" + m
	}
	if (s <= 9) {
		s = "0" + s
	}
	var str = "";
	if (day != "00") {
		str += day + "天"
	} else {
		if (h != "00") {
			str += h + "时"
		} else {
			if (m != "00") {
				str += m + "分" + s + "秒"
			} else {
				str += s + "秒"
			}
		}
	}
	return str
}

function jsDateDiff(pTime){
	var pTime = eval("new " + (pTime.replace(/\//g, "")));
	pTime.format("yyyy-MM-dd hh:mm:ss");
    var d_minutes,d_hours,d_days,d;
    var timeNow = parseInt(new Date().getTime()/1000);
    pTime_new = new Date(pTime).getTime()/1000;
    d = timeNow - pTime_new;
    d = parseInt(d);
    d_days = parseInt(d/86400);       
    d_hours = parseInt(d/3600);       
    d_minutes = parseInt(d/60);    
    if(d_days>0 && d_days<2){       
        return d_days+"天前";       
    }else if(d_days<=0 && d_hours>0){       
        return d_hours+"小时前";       
    }else if(d_hours<=0 && d_minutes>0){       
        return d_minutes+"分钟前";       
    }else if(d<60 && d>0){       
        return d+"秒前";       
    }else if(d<0){       
        return "1秒前";       
    }else{
    	return pTime.format("yyyy-MM-dd hh:mm");
    }
}

function intervalLastDate(time) {
	var d1, d2, day, h, m, s, ms, d1ms, d2ms, dms, hms, mms;
	var dms = 1000 * 60 * 60 * 24;
	var hms = 1000 * 60 * 60;
	var mms = 1000 * 60;
	var ms = time - new Date().getTime();
	if (ms <= 0) {
		day = 0;
		h = 0;
		m = 0;
		s = 0;
		ss = 0 % 1000
	} else {
		day = Math.floor(ms / dms);
		h = Math.floor(ms % dms / hms);
		m = Math.floor(ms % hms / mms);
		s = Math.floor(ms % mms / 1000);
		var ss = Math.floor(ms % 1000)
	} if (day <= 9) {
		day = "0" + day
	}
	if (h <= 9) {
		h = "0" + h
	}
	if (m <= 9) {
		m = "0" + m
	}
	if (s <= 9) {
		s = "0" + s
	}
	var str = '<em class="red">' + day + '</em>天<em class="red">' + h + '</em>时<em class="red">' + m + '</em>分<em class="red">' + s + "</em>秒";
	return str
}

function compDate(d1, d2) {
	if (!(d1 instanceof Date)) {
		return false
	}
	if (!d2) {
		d2 = new Date();
		d2.setHours(0);
		d2.setSeconds(0);
		d2.setMinutes(0);
		d2.setMilliseconds(0)
	}
	var d2mil = d2.getTime();
	if (d2mil > d1.getTime()) {
		return true
	}
	return false
}

function transToDate(dateStr) {
	var date = null;
	if (dateStr == "") {
		return null
	}
	if (dateStr.length == 8) {
		dateStr = dateStr.substring(0, 4) + "/" + dateStr.substring(4, 6) + "/" + dateStr.substring(6, 8);
		date = new Date(dateStr);
		return date
	}
	if (dateStr.indexOf("-") != -1) {
		dateStr = dateStr.replace(/-/g, "/");
		date = new Date(dateStr);
		return date
	}
	return null
}

//通用方法
function postAjax(url, data, func, async) {
	if(ajaxUrlInit.isJavaApi == true){
		url = ajaxUrlInit.basePath + '/post?url=' + encodeURIComponent(url);
	}else{
		url= ajaxUrlInit.basePath + url;
	}
    $.ajax({
        type: 'POST',
        url: url,
        data: data,
        dataType: 'json',
        contentType: "application/x-www-form-urlencoded; charset=utf-8",
        async:undefined?true:async,
        timeout: 10000,
        success: function (data) {
            if (data.success != undefined) {
                if (data.success == "true") {
                	//data=$.parseJSON(data);
                    func(data);
                } else {
                	if (data.errinfo) {
                		if($('#loadingToast')[0]){$('#loadingToast').remove()}
    					var err = "";
    					for (var o in data.errinfo) {
    						err = data.errinfo[o];
    						break
    					}
    					appToast(err);
    				}
                }
            }
        },
        error: function (xhr,type) {
            errorHandler(XMLHttpRequest, textStatus, errorThrown);
        }
    })
}

function postAjax2(url, data, func, async) {
	if(ajaxUrlInit.isJavaApi == true){
		url = ajaxUrlInit.basePath + '/post?url=' + encodeURIComponent(url);
	}else{
		url= ajaxUrlInit.basePath + url;
	}
    $.ajax({
        type: 'POST',
        url: url,
        data: data,
        dataType: 'json',
        contentType: "application/x-www-form-urlencoded; charset=utf-8",
        async:undefined?true:async,
        timeout: 10000,
        success: function (data) {
        	//data=$.parseJSON(data);
        	func(data);
        },
        error: function (xhr, type) {
            errorHandler(XMLHttpRequest, textStatus, errorThrown);
        }
    })
}

function getAjax(url, func, async) {
	if(ajaxUrlInit.isJavaApi == true){
		url = ajaxUrlInit.basePath + '/get?url=' + encodeURIComponent(url);
		//url = ajaxUrlInit.basePath + '/get?url=' +url;
	}else{
		url= ajaxUrlInit.basePath + url;
	}
    $.ajax({
        type: 'GET',
        url:url,
        dataType: "json",
        async:undefined?true:async,
        contentType: "application/x-www-form-urlencoded; charset=utf-8",
        timeout: 6000,
        success: function (data) {
            func(data);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            errorHandler(XMLHttpRequest, textStatus, errorThrown);
        }
    })
}

function getAjax2(url, func, async) {
	if(ajaxUrlInit.isJavaApi == true){
		url = ajaxUrlInit.basePath + '/get?url=' + encodeURIComponent(url);
	}else{
		url= ajaxUrlInit.basePath + url;
	}
    $.ajax({
        type: 'GET',
        url: url,
        dataType: "json",
        async:undefined?true:async,
        contentType: "text/html",
        timeout: 6000,
        success: function (data) {
            func(data);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            errorHandler(XMLHttpRequest, textStatus, errorThrown);
        }
    })
}

function getAjax3(url, func, async) {
	if(ajaxUrlInit.isJavaApi == true){
		url = ajaxUrlInit.basePath + '/get?url=' + encodeURIComponent(url);
	}else{
		url= ajaxUrlInit.basePath + url;
	}
    $.ajax({
        type: 'GET',
        url: url,
        dataType: "json",
        async:undefined?true:async,
        contentType: "text/html",
        timeout: 6000,
        success: function (data) {
            func(data);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            errorHandler(XMLHttpRequest, textStatus, errorThrown);
        }
    })
}
function getAjax4(url, func, async) {
	if(ajaxUrlInit.isJavaApi == true){
		url = ajaxUrlInit.basePath + '/get?url=' + encodeURIComponent(url);
	}else{
		url= ajaxUrlInit.basePath + url;
	}
    $.ajax({
        type: 'GET',
        url: url,
        dataType: "text",
        async:undefined?true:async,
        contentType: "text/html",
        timeout: 6000,
        success: function (data) {
            func(data);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            errorHandler(XMLHttpRequest, textStatus, errorThrown);
        }
    })
}

var errorTimeout = true;
var errorParser = true;
var errorAbort = true;
var errorOther = true;

function errorHandler(XMLHttpRequest, textStatus, errorThrown, url) {
	if (textStatus == "timeout" && errorTimeout) {
		errorTimeout = false;
		appToast("网络不给力哦！请稍后再试")
	} else {
		if ((textStatus == "error" || textStatus == "parsererror") && errorParser) {
			errorParser = false;
			//appToast("系统繁忙哦！请稍后再试。")
		} else {
			if (textStatus == "abort" && errorAbort) {
				errorAbort = false;
				appToast("网络不可用哦! 请检查你的网络")
			} else {
				if (errorOther) {
					errorOther = false;
					appToast("系统繁忙哦！请稍后再试")
				}
			}
		}
	}
	setTimeout(function(){closeLoading()},2000);
}

//滚动条在Y轴上的滚动距离
function getScrollTop(){
　　var scrollTop = 0, bodyScrollTop = 0, documentScrollTop = 0;
　　if(document.body){
　　　　bodyScrollTop = document.body.scrollTop;
　　}
　　if(document.documentElement){
　　　　documentScrollTop = document.documentElement.scrollTop;
　　}
　　scrollTop = (bodyScrollTop - documentScrollTop > 0) ? bodyScrollTop : documentScrollTop;
　　return scrollTop;
}
//文档的总高度
function getScrollHeight(){
　　var scrollHeight = 0, bodyScrollHeight = 0, documentScrollHeight = 0;
　　if(document.body){
　　　　bodyScrollHeight = document.body.scrollHeight;
　　}
　　if(document.documentElement){
　　　　documentScrollHeight = document.documentElement.scrollHeight;
　　}
　　scrollHeight = (bodyScrollHeight - documentScrollHeight > 0) ? bodyScrollHeight : documentScrollHeight;
　　return scrollHeight;
}
//浏览器视口的高度
function getWindowHeight(){
　　var windowHeight = 0;
　　if(document.compatMode == "CSS1Compat"){
　　　　windowHeight = document.documentElement.clientHeight;
　　}else{
　　　　windowHeight = document.body.clientHeight;
　　}
　　return windowHeight;
}
//返回顶部
function goTop(){
	var divObj=document.createElement('div'); 
		divObj.setAttribute('id','ScrollTop');
		divObj.innerHTML='<span class="iconfont icon-fanhuidingbu"></span>'; 
		var first=document.body.firstChild;
		document.body.insertBefore(divObj,first);
    function getScrollTop(){
            return document.documentElement.scrollTop||document.body.scrollTop;
        }
    function setScrollTop(value){
            document.documentElement.scrollTop=value;
            document.body.scrollTop=value;
        }   
    window.onscroll=function(){
    	if(getScrollTop()>0){
    		divObj.style.display="block"
    		if($('#ListHistory')[0]){$('#ListHistory').css('bottom','65px;')}
    		if($('#ListSearch')[0]){$('#ListSearch').css('bottom','110px;')}
    		if($('#InfoHome')[0]){$('#InfoHome').css('bottom','115px;')}
    	}else{
    		divObj.style.display="none";
    		if($('#ListHistory')[0]){$('#ListHistory').css('bottom','5px;')}
    		if($('#ListSearch')[0]){$('#ListSearch').css('bottom','55px;')}
    		if($('#InfoHome')[0]){$('#InfoHome').css('bottom','60px;')}
    	}
    }
    divObj.onclick=function(){
        var goTop=setInterval(scrollMove,10);
        function scrollMove(){
                setScrollTop(getScrollTop()/1.1);
                if(getScrollTop()<1)clearInterval(goTop);
            }
    }
}

//是否登录
function isLogin(fun) {
    var state = false;
    getAjax("/Passport/GetUserLoginSta",function(data){
    	state = data.UserLoginState!=null;
    	if(data.UserLoginState != null){
    		sessionStorage.setItem("local-userid",data.UserLoginState.UserId);
    		sessionStorage.setItem("local-username",data.UserLoginState.UserName);	
    	}
    	
    },false);
    fun(state);
}
function isLogin2(fun) {
    getAjax("/Passport/GetUserLoginSta",function(data){
        fun(data);
    });
}
function goLogin() {
	gopage("/home/login.html");
}

function showLoading(tex){
	if(tex == null || tex == undefined){tex='数据加载中...'}
	var html='<div id="loadingToast" style="display:block;"><div class="weui-mask_transparent"></div><div class="weui-toast"><i class="weui-loading weui-icon_toast"></i><p class="weui-toast__content">'+tex+'</p></div></div>';
	$('body').append(html);
}

function closeLoading(){
	if($('#loadingToast')[0]){$('#loadingToast').remove();}
}

/*重定义数据加载---底部加载重置*/
function emptyHtml(obj){
	obj.html("");
	$('#pageLoading').html('正在努力加载<img src="../content/img/loading.gif">').hide();
}
//弹出提示
function appToast(title) {
    var $message = $("#app-message");
    title = title || "";
    if ($message.length == 0) {
        $("body").append("<div id=\"app-message\" class=\"message-dialog\"><div>"+title+"</div></div>");
        $message = $("#app-message");
    } else {
        $message.html("<div>"+title+"</div>");
        $message.show();
    }
    setTimeout(function(){document.getElementById("app-message").style.display="none"},2000);
}

//替换文字
function keyChange(id, key, newKey){
	var oDiv = document.getElementById(id);
	var	sText = oDiv.innerHTML;  
	var	num = -1;
	var	rStr = new RegExp(key, "g");
	var	rHtml = new RegExp("\<.*?\>","ig"); //匹配html元素
	var	aHtml = sText.match(rHtml); //存放html元素的数组
		sText = sText.replace(rHtml, '{~}');  //替换html标签
		sText = sText.replace(rStr,newKey); //替换key
		sText = sText.replace(/{~}/g,function(){  //恢复html标签
	 	num++;
	 	return aHtml[num];
	});

	oDiv.innerHTML = sText;
}

var $searchBar = $('#searchBar'),
    $searchResult = $('#searchResult'),
    $searchText = $('#searchText'),
    $searchInput = $('#searchInput'),
    $searchClear = $('#searchClear'),
    $searchCancel = $('#searchCancel');

function hideSearchResult(){
    $searchResult.hide();
    $searchInput.val('');
}
function cancelSearch(){
    hideSearchResult();
    $searchBar.removeClass('weui-search-bar_focusing');
    $searchText.show();
}

$searchText.on('click', function(){
    $searchBar.addClass('weui-search-bar_focusing');
    $searchInput.focus();
});
$searchInput
    .on('blur', function () {
        if(!this.value.length) cancelSearch();
    })
    .on('input', function(){
        if(this.value.length) {
            $searchResult.show();
        } else {
            $searchResult.hide();
        }
    })
;
$searchClear.on('click', function(){
    hideSearchResult();
    $searchInput.focus();
});
$searchCancel.on('click', function(){
    cancelSearch();
    $searchInput.blur();
});

var u = navigator.userAgent, app = navigator.appVersion;
var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //android终端或者uc浏览器
var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
;(function($) {
  var DEFAULTS = {
    endY: 0,
    duration: 200,
    updateRate: 15
  };

  var interpolate = function (source, target, shift) {
    return (source + (target - source) * shift);
  };

  var easing = function (pos) {
    return (-Math.cos(pos * Math.PI) / 2) + .5;
  };

  var scroll = function(settings) {
    var options = $.extend({}, DEFAULTS, settings);

    if (options.duration === 0) {
      window.scrollTo(0, options.endY);
      if (typeof options.callback === 'function') options.callback();
      return;
    }

    var startY = window.pageYOffset,
        startT = Date.now(),
        finishT = startT + options.duration;

    var animate = function() {
      var now = Date.now(),
          shift = (now > finishT) ? 1 : (now - startT) / options.duration;

      window.scrollTo(0, interpolate(startY, options.endY, easing(shift)));

      if (now < finishT) {
        setTimeout(animate, options.updateRate);
      }
      else {
        if (typeof options.callback === 'function') options.callback();
      }
    };

    animate();
  };

  var scrollNode = function(settings) {
    var options = $.extend({}, DEFAULTS, settings);

    if (options.duration === 0) {
      this.scrollTop = options.endY;
      if (typeof options.callback === 'function') options.callback();
      return;
    }

    var startY = this.scrollTop,
        startT = Date.now(),
        finishT = startT + options.duration,
        _this = this;

    var animate = function() {
      var now = Date.now(),
          shift = (now > finishT) ? 1 : (now - startT) / options.duration;

      _this.scrollTop = interpolate(startY, options.endY, easing(shift));

      if (now < finishT) {
        setTimeout(animate, options.updateRate);
      }
      else {
        if (typeof options.callback === 'function') options.callback();
      }
    };

    animate();
  };

  $.scrollTo = scroll;

  $.fn.scrollTo = function() {
    if (this.length) {
      var args = arguments;
      this.forEach(function(elem, index) {
        scrollNode.apply(elem, args);
      });
    }
  };
}(Zepto));
//图片转换表情码
function replaceFaceCode(str) {
    //console.log(str);
    if (str == null) {
        return ""
    }
    if (typeof str == "string") {
        var reg = /<img\s.*?\s?src\s*=\s*['|"]?([^\s'"]+).*?>/ig;
        var reg2 = /\[[\u4e00-\u9fa5]+\]/ig;
        var imgHtml = str.match(reg);
        var imgCode = str.match(reg2);
        //console.log(imgCode);
        if (imgHtml) {
            for (var i = 0; i < imgHtml.length; i++) {
                str = str.replace(imgHtml[i], imgCode[i])
            }
        }
    }
    return str
}
//表情码转换图片
function replaceFaceImg(str,emojiData) {
    if (str == null) {
        return ""
    }
    if (typeof str == "string") {
        var reg2 =  /\[[\u4e00-\u9fa5]+\]/ig;
        var imgCode = str.match(reg2);
        if (imgCode) {
            for (var i = 0; i < imgCode.length; i++) {
                for(var j=0;j<emojiData.length;j++){
                    if(emojiData[j].value == imgCode[i]){
                        str = str.replace(imgCode[i], '<img src="https://static.hmlan.com/images/new_icon/new_emoji/'+emojiData[j].img+'" style="height:22px;vertical-align:text-bottom;margin:0 1px;" class="new-emoji-img"/>')
                        break
                    }
                }
            }
        }
    }
    return str
}
/**
 * Zepto picLazyLoad Plugin
 * ximan http://ons.me/484.html
 * 20140517 v1.0
 */
(function ($) {
  $.fn.picLazyLoad = function (settings) {
    var $this = $(this),
      _winScrollTop = 0,
      _winHeight = $(window).height();
    settings = $.extend(
      {
        threshold: 20,
        placeholder:
          "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsQAAA7EAZUrDhsAAAANSURBVBhXYzh8+PB/AAffA0nNPuCLAAAAAElFTkSuQmCC"
      },
      settings || {}
    );
    lazyLoadPic();
    $(window).on("scroll", function () {
      if (isScrollComment && isScrollComment!=undefined) {
        return;
      }
      _winScrollTop = $(window).scrollTop();
      lazyLoadPic();
    });
    function lazyLoadPic() {
      $this.each(function () {
        var $self = $(this);
        if ($self.is("img")) {
          if ($self.attr("data-original")) {
            var _offsetTop = $self.offset().top;
            if (_offsetTop - settings.threshold <= _winHeight + _winScrollTop) {
              $self.attr("src", $self.attr("data-original"));
              $self.removeAttr("data-original");
            }
          }
        } else {
          if ($self.attr("data-original")) {
            if ($self.css("background-image") == "none") {
              $self.css(
                "background-image",
                "url(" + settings.placeholder + ")"
              );
            }
            var _offsetTop = $self.offset().top;
            if (_offsetTop - settings.threshold <= _winHeight + _winScrollTop) {
              $self.css(
                "background-image",
                "url(" + $self.attr("data-original") + ")"
              );
              $self.removeAttr("data-original");
            }
          }
        }
      });
    }
  };
})(Zepto);
